class ReadJoiner
  include IO::Readable
  extend  IO::Openable

  def initialize(*streams)
    @streams = streams
    rewind
  end

  def sysread(length)
    buffer = ""
    return buffer if length == 0
    while buffer.length < length && @streams[@index]
      begin
        buffer << @streams[@index].sysread(length-buffer.length)
      rescue EOFError
        @index += 1
      end
    end
    return buffer if buffer.length == length || buffer.length > 0
    raise EOFError, "end of file reached", caller
  end

  def close_read
    @streams.each {|s| s.close}
    @index = @streams.size - 1 if @index >= @streams.size
    nil
  end

  def closed_read?
    @streams.all? {|s|s.closed?}
  end

  def rewind
    @streams.each {|s| s.rewind}
    self.lineno = @index = 0
  end

end

