require 'io/mixins'

class Rot13Filter
  include IO::Readable
  include IO::Writable
  include IO::Seekable
  extend  IO::Openable

  def initialize(ios)
    @ios = ios
  end

  def sysread(length)
    rot13(@ios.sysread(length))
  end
  def syswrite(string)
    @ios.syswrite(rot13(string))
  end
  def sysseek(*args)
    if @ios.respond_to?(:sysseek)
      @ios.sysseek(*args)
    else
      # StringIO is missing sysseek
      @ios.seek(*args)
      @ios.tell
    end
  end
  def close_read()  @ios.close_read  end
  def close_write() @ios.close_write end
  def close()       @ios.close       end

  private
  def rot13(string)
    string.tr("A-Za-z","N-ZA-Mn-za-m")
  end
end

